// shader type: fx                                                   
//----------------------------------------// shader name length of 40 characters
varying vec2 tcoord;

uniform float time;                     // System time for animation (in seconds)
uniform vec2 tres;                      // Center of the screen

uniform vec4 seed;                      // random value between 0 and 1
uniform vec4 audio;                     // Low, Mid, Hi energy average
uniform vec4 color;
uniform vec4 par_a;                     // Normalised ( 0.0 to 1.0 )
uniform vec4 par_b;                     // Normalised ( 0.0 to 1.0 )

uniform sampler2D tex[8];               // Array of tex samplers 
uniform int tex_l;                      // number of loaded texures  
 //f0:thickness:
//f1:offset:
//f2::

float f0 = mix(0.0, 1.0, par_a[0]);
float f1 = mix(0.0, 1.0, par_a[1]);
float f2 = mix(0.0, 1.0, par_a[2]);

float bw(vec2 coords)
{
vec4 lm;
   lm = texture2D(tex[0], coords) * vec4(0.21, 0.71, 0.07, 1.);

return lm.r+lm.g+lm.b;
}

//---------------------------------------------------------------------------------------------------
void main(void)
{
   vec2 xy = gl_FragCoord.xy;
vec2 uv = xy / tres.xy;
vec2 of = vec2(1.0 / 128.0 * f0, 1. -f1);

float bwColor = sqrt(
pow(abs(bw(uv) - bw(uv+of.xx)), 2.0) +
pow(abs(bw(uv + of.xy) - bw(uv + of.yx)), 2.0)
   );


    gl_FragColor = vec4(bwColor, bwColor, bwColor, color.a );

}//endof main



